/***************************************************************************
 *             __________               __   ___.
 *   Open      \______   \ ____   ____ |  | _\_ |__   _______  ___
 *   Source     |       _//  _ \_/ ___\|  |/ /| __ \ /  _ \  \/  /
 *   Jukebox    |    |   (  <_> )  \___|    < | \_\ (  <_> > <  <
 *   Firmware   |____|_  /\____/ \___  >__|_ \|___  /\____/__/\_ \
 *                     \/            \/     \/    \/            \/
 *
 * Copyright (C) 2006 Katie Stafford
 *
 * All files in this archive are subject to the GNU General Public License.
 * See the file COPYING in the source tree root for full license agreement.
 *
 * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
 * KIND, either express or implied.
 *
 ****************************************************************************/

#ifndef __SOUND_H_
#define __SOUND_H_

#include "common.h"
#include "mixer.h"
#include "datafile.h"

extern int musicvol;
extern int soundvol;

#if CONFIG_CODEC == SWCODEC && !defined(SIMULATOR) && !defined(SDLTEST)

void snd_mix(void) ICODE_ATTR;
void sound_get_more(uint8 ** start, size_t *size);
void loadmusic(char* fname);
void sound_init(void);
void sound_fini(void);
int load_sounds(char* fname);

void music_fade(int speed);
void music_cache(const char* nm);
void music_uncache(const char* nm);
void music_change(const char* new, int fadeout, int fadein, bool loop);
void music_wait_load(void);
int music_is_playing(void);

void playsnd(const char* name);
void playsndvol(const char* name, int lvol, int rvol);
void playsndxy(const char* name, int x, int y, int vol);

#else

#define sound_fini() (void)0
#define sound_init() (void)0
#define load_sounds(fname) (void)0
#define music_fade(x) (void)0
#define music_change(fname, fadeout, fadein, loop) (void)0
#define music_cache(x) (void)0
#define music_uncache(x) (void)0
#define music_wait_load() (void)0
#define music_is_playing() (0)

#define playsnd(name) (void)0
#define playsndvol(name, lvol, rvol) (void)0
#define playsndxy(name, x, y, vol) (void)0

#endif


#endif
